/*
 * Setgid program for writing the Pathological highscores file
 *
 * Copyright (C) 2003  John-Paul Gignac
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define HIGHSCORES "/var/games/pathological_scores"

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#define BUFFER_SIZE 1024

unsigned char buffer[BUFFER_SIZE];

void die(void)
{
	perror( "write-highscores: " HIGHSCORES);
	exit(1);
}

int main()
{
	int fd;
	size_t size;

	if( (fd = open( HIGHSCORES, O_WRONLY | O_TRUNC )) == -1) die();

	while( (size = read( 0, buffer, BUFFER_SIZE)) > 0) {
		if( write( fd, buffer, size) == -1) die();
	}

	if( close( fd) == -1) die();

	return 0;
}
